/* -*- mode: c++; c-basic-offset: 4; indent-tabs-mode: nil -*- */
#ifndef VRENUMS_H
#define VRENUMS_H

#include <vr3d/vr3d.h>

#ifndef PI
#   define PI 3.14159265358979323846f
#endif

enum COLORFORMAT {
    CF_LUMINANCE = GL_LUMINANCE,
    CF_RGB8 = GL_RGB8,
    CF_FLOAT_RGBA32 = GL_FLOAT_RGBA32_NV,
    CF_DEPTH_COMPONENT = GL_DEPTH_COMPONENT,
    CF_RGB = GL_RGB,
    CF_RGBA = GL_RGBA,
};

enum DATATYPE {
    DT_UBYTE = GL_UNSIGNED_BYTE,
    DT_FLOAT = GL_FLOAT,
    DT_UINT = GL_UNSIGNED_INT,
    DT_INT = GL_INT,
    DT_DEPTH_COMPONENT = GL_DEPTH_COMPONENT,
    DT_DEPTH_COMPONENT32F = GL_DEPTH_COMPONENT32F_NV,
};

enum TEXFILTER {
    TF_NEAREST = GL_NEAREST,
    TF_LINEAR = GL_LINEAR,
};

enum TEXTARGET {
    TT_TEXTURE_1D = GL_TEXTURE_1D,
    TT_TEXTURE_2D = GL_TEXTURE_2D,
    TT_TEXTURE_RECTANGLE = GL_TEXTURE_RECTANGLE_NV,
    TT_TEXTURE_3D = GL_TEXTURE_3D,
};

enum TEXWRAP {
    TW_CLAMP = GL_CLAMP,
    TW_CLAMP_TO_EDGE = GL_CLAMP_TO_EDGE,
    TW_REPEAT = GL_REPEAT,
    TW_MIRROR = GL_MIRRORED_REPEAT,
};

#endif
